%define dist_version 2_9_0
%define jaxp_version 1.3
%define jaxp_altlevel 130

Name: xerces-j
Version: 2.9.0
Release: alt2

%def_enable tools
%def_disable samples

%define pkgdocdir	%_docdir/%name-%version

Summary: Java XML parser
Group: System/Libraries
License: Apache
Url: http://xml.apache.org/xerces2-j/

Provides:       jaxp_parser_impl
Provides:       xerces-j2-dom3
Provides:       xerces-j2 = %dist_version-%release

Provides: jaxp_parser_impl = %jaxp_version

Requires:       xml-commons-apis >= 0:1.3
Requires:       xml-commons-resolver >= 1.1
Requires(post): alternatives >= 0.2.0
Requires(preun): alternatives >= 0.2.0

Source0: http://xml.apache.org/dist/xerces-j/Xerces-J-src.%version.tar.gz
Source1: http://xml.apache.org/dist/xerces-j/Xerces-J-tools.%version.tar.gz
# other way is
#BuildRequires:  xml-stylebook
#BuildRequires:  xalan-j2


# viy: added from JPackage
Source11:        xerces-j2-version.sh
Source12:        xerces-j2-constants.sh


Patch0: %name-2.7.1-build.sh.patch
Patch1: %name-2.9.0-build.xml.patch

BuildArch: noarch

BuildPreReq: rpm-build-java
BuildRequires: /proc
BuildRequires: java-devel
BuildRequires: ant
BuildRequires:  xml-commons-resolver11 >= 0:1.1
BuildRequires:  xml-commons-apis >= 0:1.3
# viy: use -Djava.awt.headless=true -Ddisconnected=true instead
#BuildRequires: xvfb-run
BuildPreReq: jpackage-utils
# not needed
#BuildRequires: libXi libXt

%description
Xerces2 is the next generation of high performance, fully compliant
XML parsers in the Apache Xerces family. This new version of Xerces
introduces the Xerces Native Interface (XNI), a complete framework for
building parser components and configurations that is extremely
modular and easy to program.  The Apache Xerces2 parser is the
reference implementation of XNI but other parser components,
configurations, and parsers can be written using the Xerces Native
Interface. For complete design and implementation documents, refer to
the XNI Manual.  Xerces 2 is a fully conforming XML Schema
processor. For more information, refer to the XML Schema page.  Xerces
2 also provides a partial implementation of Document Object Model
Level 3 Core, Load and Save and Abstract Schemas [deprecated] Working
Drafts.  For more information, refer to the DOM Level 3 Implementation
page.

%package manual
Summary: Manual for %name
Group: Development/Java
Requires: %name-javadoc = %version-%release

%description manual
Documentation for Xerces, a Java XML parser.

%package javadoc
Summary: Javadoc for %name
Group: Development/Java
# viy:
#Requires: xml-commons-external-javadoc
AutoReqProv: no
# viy: some packages do require them
Provides: xerces-j2-javadoc-apis = %version-%release
Provides: xerces-j2-javadoc-xni = %version-%release
Provides: xerces-j2-javadoc-impl = %version-%release
Provides: xerces-j2-javadoc-other = %version-%release

%description javadoc
Javadoc for Xerces, a Java XML parser.

%package demo
Summary: Demo for %name
Group: Development/Java
Requires: %name = %version-%release

%description demo
Demonstrations and samples for Xerces, a Java XML parser.

%package        scripts
Summary:        Additional utility scripts for %{name}
Group:          Development/Java
Requires:       %{name} = %{version}-%{release}
Requires:       jpackage-utils >= 0:1.6

%description    scripts
Additional utility scripts for %{name}.

%prep
%setup -q -n xerces-%dist_version
%if_enabled tools
%setup -q -n xerces-%dist_version -T -D -a 1
%endif
#patch0
%patch1 -p1

%if_enabled tools
pushd tools
ln -sf $(build-classpath xml-commons-apis) .
ln -sf $(build-classpath xml-commons-resolver) .
popd
%endif

%build
%if_enabled samples
%define targets jar sampjar javadocs docs
%else
%define targets jar javadocs docs
%endif

# %if_enabled tools
# export JAVA_HOME=/usr/lib/jdk
# xvfb-run sh build.sh %targets
# %else	# disabled tools
# xvfb-run ant \
#     -Dbuild.compiler=modern \
#     -Dtools.dir=%{_javadir} \
#     -Djar.apis=xml-commons-external.jar \
#     %targets
# %endif	# enabled tools

export ANT_OPTS="-Xmx256m -Djava.endorsed.dirs=$(pwd)/tools -Djava.awt.headless=true -Dbuild.sysclasspath=first -Ddisconnected=true"
sh build.sh \
        -Dbuild.compiler=modern \
        -Djar.apis=xml-commons-apis.jar \
        -Djar.resolver=xml-commons-resolver.jar \
        clean %targets

%install
# jars
install -d -m755 $RPM_BUILD_ROOT%_javadir/
install -m644 build/xercesImpl.jar $RPM_BUILD_ROOT%_javadir/xerces-j2-%version.jar
ln -s xerces-j2-%version.jar $RPM_BUILD_ROOT%_javadir/dom3-xerces-j2-%version.jar
ln -s xerces-j2-%version.jar $RPM_BUILD_ROOT%_javadir/xerces-j2.jar
ln -s xerces-j2-%version.jar $RPM_BUILD_ROOT%_javadir/xerces.jar

# manual
install -d -m755 $RPM_BUILD_ROOT%pkgdocdir
cp -a build/docs/* $RPM_BUILD_ROOT%pkgdocdir
# boilerplate docs
install -p -m644 LICENSE README NOTICE $RPM_BUILD_ROOT%pkgdocdir/
# # javadoc
# mkdir -p $RPM_BUILD_ROOT%_javadocdir
# mv -f $RPM_BUILD_ROOT%pkgdocdir/javadocs $RPM_BUILD_ROOT%_javadocdir/%name
# ln -s $(relative %_javadocdir/%name %pkgdocdir/) \
#     $RPM_BUILD_ROOT%pkgdocdir/javadocs
# rm -rf $RPM_BUILD_ROOT%_javadocdir/%name/api
# #ln -s ../xml-commons-external $RPM_BUILD_ROOT%_javadocdir/%name/api

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-impl-%{version}
cp -pr build/docs/javadocs/xerces2/* \
  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-impl-%{version}
ln -s %{name}-impl-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}-impl

mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-apis-%{version}
cp -pr build/docs/javadocs/api/* \
  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-apis-%{version}
ln -s %{name}-apis-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}-apis

mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-xni-%{version}
cp -pr build/docs/javadocs/xni/* \
  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-xni-%{version}
ln -s %{name}-xni-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}-xni

mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-other-%{version}
cp -pr build/docs/javadocs/other/* \
  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-other-%{version}
ln -s %{name}-other-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}-other

rm -rf build/docs/javadocs
##################

# scripts
mkdir -p $RPM_BUILD_ROOT%{_bindir}
install -m 755 %{SOURCE11} $RPM_BUILD_ROOT%{_bindir}/xerces-j2-version
install -m 755 %{SOURCE12} $RPM_BUILD_ROOT%{_bindir}/xerces-j2-constants

%if_enabled samples
# demo
install -d -m755 $RPM_BUILD_ROOT%_datadir/%name
install -p -m644 build/xercesSamples.jar $RPM_BUILD_ROOT%_datadir/%name/%name-samples.jar
cp -a data $RPM_BUILD_ROOT%_datadir/%name
%endif	# enabled samples

mkdir -p $RPM_BUILD_ROOT%_altdir
cat <<EOF >$RPM_BUILD_ROOT%_altdir/%name
%_javadir/jaxp_parser_impl.jar	%_javadir/xerces-j2.jar	%jaxp_altlevel
EOF

%post
%register_alternatives %name -- jaxp_parser_impl

%preun
%unregister_alternatives %name

%files
%dir %pkgdocdir
%pkgdocdir/LICENSE
%pkgdocdir/NOTICE
%pkgdocdir/README
%_javadir/*
%_altdir/%name

%files manual
%dir %pkgdocdir
%pkgdocdir/[a-z]*

%files javadoc
%_javadocdir/*

%if_enabled samples
%files demo
%_datadir/%name
%endif	# enabled samples

%files scripts
%{_bindir}/*

%changelog
* Mon May 21 2007 Igor Vlasenko <viy@altlinux.ru> 2.9.0-alt2
- NMU: 
  * fixes for X-less build
  * fixed bug in alternatives (jaxp_parser_impl.jar)
  * javadocs are split almost as they should be
  * added scripts subpackage

* Tue Apr 24 2007 Eugene Ostapets <eostapets@altlinux.ru> 2.9.0-alt1
- 2.9.0 

* Tue Apr 24 2007 Eugene Ostapets <eostapets@altlinux.ru> 2.8.1-alt2
- fix build with java-1.6-sun
- add compatibility with JPackage

* Wed Nov 15 2006 Eugene Ostapets <eostapets@altlinux.ru> 2.8.1-alt1
- 2.8.1

* Sat Mar 11 2006 Mikhail Zabaluev <mhz@altlinux.ru> 2.8.0-alt1
- 2.8.0
- Updated Patch1

* Sun Feb 26 2006 Mikhail Zabaluev <mhz@altlinux.ru> 2.7.1-alt2
- Fixes to build with JDK 1.5

* Wed Jul 27 2005 Mikhail Zabaluev <mhz@altlinux.ru> 2.7.1-alt1
- New upstream release

* Mon Jun 27 2005 Mikhail Zabaluev <mhz@altlinux.ru> 2.7.0-alt1
- New upstream release
- Raised jaxp_parser_impl.jar alternative level to 130
  to reflect the JAXP 1.3 implementation
- Updated Patch1
- Use rpm-build-java macros
- Conditionally build samples, disabled by default
  (can not compile with 1.4.2)

* Tue Aug 31 2004 Mikhail Zabaluev <mhz@altlinux.ru> 2.6.2-alt2
- New alternatives format

* Mon Mar 08 2004 Mikhail Zabaluev <mhz@altlinux.ru> 2.6.2-alt1
- Remove JDK version hardcoding

* Sun Feb 22 2004 Mikhail Zabaluev <mhz@altlinux.ru> 2.6.2-alt0.1
- Updated to upstream release 2.6.2

* Wed Jan 21 2004 Mikhail Zabaluev <mhz@altlinux.ru> 2.6.0-alt3.1
- Temporarily hardcode the JDK

* Sat Dec 20 2003 Mikhail Zabaluev <mhz@altlinux.ru> 2.6.0-alt3
- Patches from Alexey Borovskoy
- Use xvfb-run to start fake X server
- Migration to new alternatives scheme

* Sat Dec 20 2003 Mikhail Zabaluev <mhz@altlinux.ru> 2.6.0-alt2
- Added update-alternatives to install-time dependencies
- Corrected timing of updating alternatives during uninstall/upgrade
- Set JAVA_HOME to the commonly known J2SE directory

* Thu Dec 11 2003 Mikhail Zabaluev <mhz@altlinux.ru> 2.6.0-alt1
- New upstream release

* Thu Sep 11 2003 Mikhail Zabaluev <mhz@altlinux.ru> 2.5.0-alt1
- Updated to 2.5.0, renamed to xerces-j because xerces 1.x is obsolete
- Dropped README from the docs as it contains nothing but build instructions
- Remove JAXP api docs from javadoc, link to xml-commons-apis instead

* Sun Nov 17 2002 Mikhail Zabaluev <mhz@altlinux.ru> 2.2.1-alt1
- Ported the package over from the JPackage project. Thank you guys.
